


#include <p18f26j11.h>

#include "h/FctnUSART.h"
#include "h/Parametres.h"
#include "h/JeuBatonnets.h"
#include "h/JeuMunstermind.h"
#include "h/Utilitaires.h"


void InitUSART1(void)
{
	SPBRGH1 = 0;
	SPBRG1 = 99;

	BAUDCON1bits.BRG16 = 0;
	TXSTA1bits.SYNC = 0;

	RCSTA1bits.SPEN = 1;

	RCSTA1bits.RX9 = 0;
	RCSTA1bits.CREN = 1;	

	TXSTA1bits.TXEN = 1;
}

void InitUSART2(void)
{
	RPOR5 = 0x05;
	RPINR16 = 0x06;

	SPBRGH2 = 0;
	SPBRG2 = 99;

	BAUDCON2bits.BRG16 = 0;
	TXSTA2bits.SYNC = 0;

	RCSTA2bits.SPEN = 1;

	RCSTA2bits.RX9 = 0;
	RCSTA2bits.CREN = 1;

	TXSTA2bits.TXEN = 1;	
}

unsigned char CalculParitePaire(unsigned char Donnee)
{
	unsigned char k;
	unsigned char Contenu = 0;

	for(k = 0; k < 8; k++)
	{
		if(((Donnee >> k) & 0x01) == 1)
		{
			Contenu ^= 1;
		}
	}

	return (Donnee | (0x80 & (Contenu << 7)));
}

void EnvoyerUSART1(unsigned char Donnee)
{
	while(TXSTA1bits.TRMT == 0);

	TXREG1 = CalculParitePaire(Donnee);
}

void EnvoyerUSART2(unsigned char Donnee)
{
	while(TXSTA2bits.TRMT == 0);

	TXREG2 = CalculParitePaire(Donnee);
}

unsigned char RecevoirUSART1(void)
{
	while(PIR1bits.RC1IF == 0);

	return RCREG1;
}

unsigned char RecevoirUSART2(void)
{
	while(PIR3bits.RC2IF == 0);

	return RCREG2;
}

void EnvoyerALExterieur(unsigned char Donnee)
{
	Delai(500);
	EnvoyerUSART2(Donnee);
	Delai(500);	
}

unsigned char RecevoirDeLExterieur(void)
{
	/* Masquage du bit de parit */

	return (0x7F & RecevoirUSART2());
}


