

#include "h/JeuBatonnets.h"
#include "h/Affichages.h"
#include "h/FctnADC.h"
#include "h/SemiGraphique.h"
#include "h/Utilitaires.h"


void InitJeuBatonnets(void)
{
	EnvoyerAuMinitel(0x0C);
	EnvoyerAuMinitel(0x14);
	EnvoyerAuMinitel(0x1E);
	
	PositionnerCurseurMinitel(2, 1);
	ChoisirUnAttribut(MINITEL_LARGEUR_HAUTEUR_DOUBLES);
	AfficheTexteMinitel("3615 BATONNETS\0");
	ChoisirUnAttribut(MINITEL_LARGEUR_HAUTEUR_NORMALES);

	Delai(9000);


	PositionnerCurseurMinitel(3, 1);
	AfficheTexteMinitel("    ...................................\0");
	PositionnerCurseurMinitel(4, 1);
	AfficheTexteMinitel("    .M....M. ..M....M....M....M....M...\0");
	PositionnerCurseurMinitel(5, 1);
	AfficheTexteMinitel("    MMM..MMM .MMM..MMM..MMM..MMM..MMM..\0");
	PositionnerCurseurMinitel(6, 1);
	AfficheTexteMinitel("    MMM..MMM .MMM..MMM..MMM..MMM..MMM..\0");
	PositionnerCurseurMinitel(7, 1);
	AfficheTexteMinitel("    MMM..MMM .MMM..MMM..MMM..MMM..MMM..\0");
	PositionnerCurseurMinitel(8, 1);
	AfficheTexteMinitel("    MMM..MMM .MMM..MMM..MMM..MMM..MMM..\0");
	PositionnerCurseurMinitel(9, 1);
	AfficheTexteMinitel("    MMM..MMM .MMM..MMM..MMM..MMM..MMM..\0");
	PositionnerCurseurMinitel(10, 1);
	AfficheTexteMinitel("    MMM..MMM .MMM..MMM..MMM..MMM..MMM..\0");
	PositionnerCurseurMinitel(11, 1);
	AfficheTexteMinitel("    MMM..MMM .MMM..MMM..MMM..MMM..MMM..\0");
	PositionnerCurseurMinitel(12, 1);
	AfficheTexteMinitel(".....M....M.   M    M    M    M    M  \0");
	PositionnerCurseurMinitel(13, 1);
	AfficheTexteMinitel("............   .                        \0");

	PositionnerCurseurMinitel(15, 1);
	AfficheTexteMinitel("AFIN DE POUVOIR JOUER DANS DE BONNES\0");
	PositionnerCurseurMinitel(16, 1);
	AfficheTexteMinitel("CONDITIONS, DESACTIVEZ L'ECHO LOCAL\0");
	PositionnerCurseurMinitel(17, 1);
	AfficheTexteMinitel("DU MINITEL.\0");
	PositionnerCurseurMinitel(19, 1);
	AfficheTexteMinitel("POUR CE FAIRE, APPUYEZ SIMULTANEMENT SUR\0");
	PositionnerCurseurMinitel(20, 1);
	AfficheTexteMinitel("LA TOUCHE \"Fcnt\" ET SUR LA TOUCHE \"T\",\0");
	PositionnerCurseurMinitel(21, 1);
	AfficheTexteMinitel("PUIS APPUYEZ SUR LA TOUCHE \"E\".\0");
	PositionnerCurseurMinitel(23, 1);
	AfficheTexteMinitel("APPUYEZ ENSUITE SUR LA TOUCHE \"ENTREE\",\0");
	PositionnerCurseurMinitel(24, 1);
	AfficheTexteMinitel("POUR AINSI COMMENCER LE JEU !\0");

 	while(RecevoirDuMinitel() != MINITEL_CARACTERE_RETOUR_LIGNE);

	EnvoyerAuMinitel(MINITEL_CARACTERE_EFFACEMENT_ECRAN);
	EnvoyerAuMinitel(MINITEL_CURSEUR_DESACTIVE);
	AfficheTexteMinitel("3615 BATONNETS\0");
	AccederNombreBatonnets(1, BATONNETS_PRISE_JOUEUR, 0);
	AccederNombreBatonnets(1, BATONNETS_PRISE_MACHINE, 0);
	AccederNombreBatonnets(1, BATONNETS_RESTANTS_JEU, AttribuerNombreBatonnets());
}

unsigned char AttribuerNombreBatonnets(void)
{
	unsigned char NombreBatonnets;

	NombreBatonnets = NombrePseudoAleatoire(17, 27);
		
	if((NombreBatonnets % 4) == 1)	/* Si le nombre de batonnets ne permet pas au joueur de gagner */
	{
		if(NombreBatonnets <= 26)
		{
			NombreBatonnets++;
		}
		else
		{
			NombreBatonnets = 17;
		}
	}

	return NombreBatonnets;
}

unsigned char AccederNombreBatonnets(unsigned char Modification, unsigned char Categorie, unsigned char Valeur)
{
	static unsigned char NombreBatonnets[3] = {0};

	if(Modification == 1)
	{
		NombreBatonnets[Categorie] = Valeur;
	}

	return NombreBatonnets[Categorie];
}

unsigned char PriseBatonnetsMachine(unsigned char BatonnetsRestants)
{
	unsigned char BatonnetsPriseMachine;
	unsigned char Reste;

	if(BatonnetsRestants > 1)	/* S'il reste plus d'un btonnet */
	{
		Reste = (BatonnetsRestants % 4);
		if(Reste == 0)	/* Si le nombre de btonnets restants est de 4, 8, 12, 16, 20 ou 24,
						la machine est dans une position gagnante */
		{
			BatonnetsPriseMachine = 3;
		}
		else if(Reste == 1)	/* Si le nombre de btonnets restants est de 5, 9, 13, 17, 21 ou 25,
							la machine est dans une position perdante */
		{
			BatonnetsPriseMachine = NombrePseudoAleatoire(1, 3);
		}
		else	/* Si le nombre de btonnets restants est de 2, 3, 6, 7, 10, 11, 14, 15, 18, 19, 22, 23, 26 ou 27,
						la machine est dans une position gagnante */ 
		{
			BatonnetsPriseMachine = (Reste - 1);
		}
	}
	else	/* S'il reste zro ou un btonnet */
	{
		BatonnetsPriseMachine = 0;	/* La machine a perdu */
	}

	return BatonnetsPriseMachine;
}

unsigned char PrendreJeuBatonnets(unsigned char Tour)
{
	unsigned char Tampon;
	unsigned char Reponse;
	unsigned char Resultat = 0;

	Tampon = AccederNombreBatonnets(0, BATONNETS_RESTANTS_JEU, 0);
	if(Tour == 0)	/* Machine */
	{
		if(Tampon >= 1)
		{
			Reponse = PriseBatonnetsMachine(Tampon);
			if(Reponse == 0)
			{
				Resultat = 1;
				PositionnerCurseurMinitel(22, 2);
				AfficheTexteMinitel("LA MACHINE A LE DERNIER BATONNET\0");
			}
			else
			{
				Tampon = (Tampon - Reponse);
				PositionnerCurseurMinitel(22, 2);
				AfficheTexteMinitel("LA MACHINE PREND \0");
				EnvoyerAuMinitel(0x30 + Reponse);
				AfficheTexteMinitel(" BATONNET\0");
				if(Reponse >= 2)
				{
					EnvoyerAuMinitel('S');
				}
				AfficheTexteMinitel("...\0");

				AccederNombreBatonnets(1, BATONNETS_RESTANTS_JEU, Tampon);
				AccederNombreBatonnets(1, BATONNETS_PRISE_MACHINE, Reponse);
				if(Tampon == 1)
				{
					Resultat = 2;
				}
			}
		}
		else
		{
			Resultat = 2;
		}
	}
	else if(Tour == 1)	/* Joueur */
	{
		AfficherDemandeSaisie(2, 22, "NOMBRE DE BATONNETS A PRENDRE ?\0");
		Reponse = ReponseJoueurBatonnets();
		EffacerDemandeSaisie(2, 22, ("PRISE DE \0"));
		EnvoyerAuMinitel(Reponse);
		AfficheTexteMinitel(" BATONNET\0");
		if(Reponse >= '2')
		{
			EnvoyerAuMinitel('S');
		}
		AfficheTexteMinitel("...\0");

		Reponse = (Reponse - 0x30);

		AccederNombreBatonnets(1, BATONNETS_RESTANTS_JEU, (Tampon - Reponse));
		AccederNombreBatonnets(1, BATONNETS_PRISE_JOUEUR, Reponse);
	}

	return Resultat;
}

void AfficherRapportJeuBatonnets(unsigned char PriseMachine, unsigned char PriseJoueur)
{
	PositionnerCurseurMinitel(20, 2);
}

void CompleterRecapitulatifJeuBatonnets(unsigned char Reinitialisation, unsigned char Tour)
{
	unsigned char k;
	unsigned char Tampon;

	static unsigned char BatonnetsJoueur = 0;
	static unsigned char BatonnetsMachine = 0;

	if(Reinitialisation == 1)
	{
		BatonnetsJoueur = 0;
		BatonnetsMachine = 0;

		PositionnerCurseurMinitel(10, 2);
		AfficheTexteMinitel("Jeu : \0");

		Tampon = AccederNombreBatonnets(0, BATONNETS_RESTANTS_JEU, 0);
		PositionnerCurseurMinitel(11, 2);
		if(Tampon >= 10)
		{
			EnvoyerAuMinitel(0x30 + (Tampon / 10));
		}
		EnvoyerAuMinitel(0x30 + (Tampon % 10));
		EnvoyerAuMinitel(' ');

		PositionnerCurseurMinitel(16, 2);
		AfficheTexteMinitel("Vous : \0");
		PositionnerCurseurMinitel(17, 2);
		EnvoyerAuMinitel('0');

		PositionnerCurseurMinitel(5, 2);
		AfficheTexteMinitel("Machine : \0");
		PositionnerCurseurMinitel(6, 2);
		EnvoyerAuMinitel('0');

		for(k = 0; k < Tampon; k++)
		{
			DessinerBatonnet(MINITEL_COULEUR_CARACTERE_BLANC, 4, (12 + k), 10);
		}
	}
	else
	{
		AfficherRapportJeuBatonnets(AccederNombreBatonnets(0, BATONNETS_PRISE_MACHINE, 0), AccederNombreBatonnets(0, BATONNETS_PRISE_JOUEUR, 0));
	}

	if((Reinitialisation == 1) || (Tour == 0))
	{
		Tampon = AccederNombreBatonnets(0, BATONNETS_PRISE_MACHINE, 0);
		BatonnetsMachine = (BatonnetsMachine + Tampon);

		for(k = 0; k < Tampon; k++)
		{
			EffacerBatonnet(4, (11 + (AccederNombreBatonnets(0, BATONNETS_RESTANTS_JEU, 0) + Tampon) - k), 10);
			DessinerBatonnet(MINITEL_COULEUR_CARACTERE_ROUGE, 4, (12 + (BatonnetsMachine - Tampon) + k), 4);
			Delai(10000);
		}

		Tampon = AccederNombreBatonnets(0, BATONNETS_RESTANTS_JEU, 0);
		PositionnerCurseurMinitel(11, 2);
		if(Tampon >= 10)
		{
			EnvoyerAuMinitel(0x30 + (Tampon / 10));
		}
		EnvoyerAuMinitel(0x30 + (Tampon % 10));
		EnvoyerAuMinitel(' ');

		PositionnerCurseurMinitel(6, 2);
		if(BatonnetsMachine >= 10)
		{
			EnvoyerAuMinitel(0x30 + (BatonnetsMachine / 10));
		}
		EnvoyerAuMinitel(0x30 + (BatonnetsMachine % 10));
		EnvoyerAuMinitel(' ');
	}

	if((Reinitialisation == 1) || (Tour == 1))
	{
		Tampon = AccederNombreBatonnets(0, BATONNETS_PRISE_JOUEUR, 0);
		BatonnetsJoueur = (BatonnetsJoueur + Tampon);

		for(k = 0; k < Tampon; k++)
		{
			EffacerBatonnet(4, (11 + (AccederNombreBatonnets(0, BATONNETS_RESTANTS_JEU, 0) + Tampon) - k), 10);
			DessinerBatonnet(MINITEL_COULEUR_CARACTERE_ROUGE, 4, (12 + (BatonnetsJoueur - Tampon) + k), 16);
			Delai(10000);
		}

		Tampon = AccederNombreBatonnets(0, BATONNETS_RESTANTS_JEU, 0);
		PositionnerCurseurMinitel(11, 2);
		if(Tampon >= 10)
		{
			EnvoyerAuMinitel(0x30 + (Tampon / 10));
		}
		EnvoyerAuMinitel(0x30 + (Tampon % 10));
		EnvoyerAuMinitel(' ');

		PositionnerCurseurMinitel(17, 2);
		if(BatonnetsJoueur >= 10)
		{
			EnvoyerAuMinitel(0x30 + (BatonnetsJoueur / 10));
		}
		EnvoyerAuMinitel(0x30 + (BatonnetsJoueur % 10));
		EnvoyerAuMinitel(' ');
	}
}

unsigned char ReponseJoueurBatonnets(void)
{
	unsigned char Tampon;
	unsigned char Touche;
	unsigned char Reponse;
	unsigned char Etat = 0;

	Tampon = AccederNombreBatonnets(0, BATONNETS_RESTANTS_JEU, 0);

	do
	{
		switch(Etat)
		{
			case 0 :
			{
				PositionnerCurseurMinitel(23, 3);
				EnvoyerAuMinitel(' ');
				PositionnerCurseurMinitel(23, 3);
				do
				{
					do
					{
						Touche = RecevoirDuMinitel();
					}
					while((Touche != '1') && (Touche != '2') && (Touche != '3'));
				}
				while((Touche - 0x30) > Tampon);
				Reponse = Touche;
				EnvoyerAuMinitel(Reponse);
				Etat = 1;

				break;
			}
			case 1 :
			{
				Touche = RecevoirDuMinitel();

				if(Touche == ' ')
				{
					Etat = 0;
				}
				else if(Touche == MINITEL_CARACTERE_RETOUR_LIGNE)
				{
					Etat = 2;
				}

				break;
			}
			case 2 :
			{

				break;
			}
			default :
			{
				Etat = 0;

				break;
			}
		}
	}
	while(Etat != 2);

	return Reponse;
}


