
#include "h/JeuMunstermind.h"
#include "h/FctnADC.h"
#include "h/Affichages.h"
#include "h/Parametres.h"
#include "h/Utilitaires.h"


void InitJeuMunstermind(void)
{
	EnvoyerAuMinitel(0x0C);
	EnvoyerAuMinitel(0x14);
	EnvoyerAuMinitel(0x1E);
	
	PositionnerCurseurMinitel(2, 1);
	ChoisirUnAttribut(MINITEL_LARGEUR_HAUTEUR_DOUBLES);
	AfficheTexteMinitel("3615 MUNSTERMIND\0");
	ChoisirUnAttribut(MINITEL_LARGEUR_HAUTEUR_NORMALES);

	Delai(9000);


	PositionnerCurseurMinitel(3, 1);
	AfficheTexteMinitel("    ...................................\0");
	PositionnerCurseurMinitel(4, 1);
	AfficheTexteMinitel("    ........ ...MMMMMMMMMM.............\0");
	PositionnerCurseurMinitel(5, 1);
	AfficheTexteMinitel("    ........MMMMMMMMMMMMMM.............\0");
	PositionnerCurseurMinitel(6, 1);
	AfficheTexteMinitel("    ...MMMMMMMMMMMMMMMMMMM.............\0");
	PositionnerCurseurMinitel(7, 1);
	AfficheTexteMinitel("    MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM...\0");
	PositionnerCurseurMinitel(8, 1);
	AfficheTexteMinitel("    MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM..\0");
	PositionnerCurseurMinitel(9, 1);
	AfficheTexteMinitel("    MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM..\0");
	PositionnerCurseurMinitel(10, 1);
	AfficheTexteMinitel("    MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM..\0");
	PositionnerCurseurMinitel(11, 1);
	AfficheTexteMinitel("    ..MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM..\0");
	PositionnerCurseurMinitel(12, 1);
	AfficheTexteMinitel("..........MMMMMMMMMMMMMMMMMMMMMMMM...  \0");
	PositionnerCurseurMinitel(13, 1);
	AfficheTexteMinitel("............   .                        \0");
 
	PositionnerCurseurMinitel(15, 1);
	AfficheTexteMinitel("AFIN DE POUVOIR JOUER DANS DE BONNES\0");
	PositionnerCurseurMinitel(16, 1);
	AfficheTexteMinitel("CONDITIONS, DESACTIVEZ L'ECHO LOCAL\0");
	PositionnerCurseurMinitel(17, 1);
	AfficheTexteMinitel("DU MINITEL.\0");
	PositionnerCurseurMinitel(19, 1);
	AfficheTexteMinitel("POUR CE FAIRE, APPUYEZ SIMULTANEMENT SUR\0");
	PositionnerCurseurMinitel(20, 1);
	AfficheTexteMinitel("LA TOUCHE \"Fcnt\" ET SUR LA TOUCHE \"T\",\0");
	PositionnerCurseurMinitel(21, 1);
	AfficheTexteMinitel("PUIS APPUYEZ SUR LA TOUCHE \"E\".\0");
	PositionnerCurseurMinitel(23, 1);
	AfficheTexteMinitel("APPUYEZ ENSUITE SUR LA TOUCHE \"ENTREE\",\0");
	PositionnerCurseurMinitel(24, 1);
	AfficheTexteMinitel("POUR AINSI COMMENCER LE JEU !\0");

 	while(RecevoirDuMinitel() != MINITEL_CARACTERE_RETOUR_LIGNE);

	EnvoyerAuMinitel(MINITEL_CARACTERE_EFFACEMENT_ECRAN);
	EnvoyerAuMinitel(MINITEL_CURSEUR_DESACTIVE);
	AfficheTexteMinitel("3615 MUNSTERMIND\0");
	AccederATentativesJeuMunstermind(1, 0);
	GenererCode();
}

unsigned char AccederATentativesJeuMunstermind(unsigned char Modification, unsigned char Valeur)
{
	static unsigned char Tentative = 0;

	if(Modification == 1)
	{
		Tentative = Valeur;
	}

	return Tentative;
}

void AccederAuxCodes(unsigned char Modification, unsigned char Categorie, unsigned char Valeur[])
{
	unsigned char k;

	static unsigned char CodeATrouver[4] = {'0'};
	static unsigned char CodePropose[4] = {'0'};

	if(Modification == 1)
	{
		if(Categorie == CODE_A_TROUVER)
		{
			for(k = 0; k < 4; k++)
			{
				CodeATrouver[k] = Valeur[k];
			}
		}
		else if(Categorie == CODE_PROPOSE)
		{
			for(k = 0; k < 4; k++)
			{
				CodePropose[k] = Valeur[k];
			}
		}
	}

	if(Categorie == CODE_A_TROUVER)
	{
		for(k = 0; k < 4; k++)
		{
			Valeur[k] = CodeATrouver[k];
		}
	}
	else if(Categorie == CODE_PROPOSE)
	{
		for(k = 0; k < 4; k++)
		{
			Valeur[k] = CodePropose[k];
		}
	}
}

void GenererCode()
{
	unsigned char k;

	unsigned char Code[4];

	for(k = 0; k < 4; k++)
	{
		Code[k] = NombrePseudoAleatoire('0', '9');
	}

	AccederAuxCodes(1, CODE_A_TROUVER, Code);
}

unsigned char IndiquerBienPlaces(unsigned char Code[], unsigned char Proposition[])
{
	unsigned char k;
	unsigned char BiensPlaces = 0;

	for(k = 0; k < 4; k++)
	{
		if(Code[k] == Proposition[k])
		{
			BiensPlaces++;
		}
	}

	return BiensPlaces;
}

unsigned char IndiquerMalPlaces(unsigned char Code[], unsigned char Proposition[])
{
	unsigned char k;
	unsigned char p;

	unsigned char MalPlaces = 0;

	unsigned char Verification = 0;

	unsigned char Testes1[4] = {0};
	unsigned char Testes2[4] = {0};

	/* Marquage des chiffres bien placs,  ne pas compter ici */
	for(k = 0; k < 4; k++)
	{
		if(Code[k] == Proposition[k])
		{
			Testes1[k] = 1;
		}
	}

	for(k = 0; k < 4; k++)
	{
		if(Testes1[k] == 0)
		{
			for(p = 0; p < 4; p++)
			{
				if((Testes2[p] == 0) && (Testes2[p] == 0) && (p != k) && (Verification == 0))
				{
					if((Code[k] == Proposition[p]) && (Testes1[p] == 0))
					{
						MalPlaces++;
						Verification = 1;
						Testes2[p] = 1;
					}
				}
			}
			Verification = 0;
		}					
	}

	return MalPlaces;
}

unsigned char PrendreJeuMunstermind(unsigned char Tour)
{
	unsigned char k;
	unsigned char Reponse;
	unsigned char Tentatives;
	unsigned char Resultat = 0;

	unsigned char TamponCode[4];
	unsigned char TamponProposition[4];

	AccederAuxCodes(0, CODE_A_TROUVER, TamponCode);
	AccederAuxCodes(0, CODE_PROPOSE, TamponProposition);

	Tentatives = AccederATentativesJeuMunstermind(0, 0);
	if(Tour == 0)	/* Adversaire */
	{
		
	}
	else if(Tour == 1)	/* Joueur */
	{
		if((Tentatives >= 1) && (IndiquerBienPlaces(TamponCode, TamponProposition) >= 4))
		{
			Resultat = 1;
		}
		else
		{
			if(Tentatives < 11)
			{
				AfficherDemandeSaisie(2, 22, "CODE A ESSAYER ?\0");
				ReponseJoueurMunstermind(TamponProposition);
				EffacerDemandeSaisie(2, 22, "ESSAI DE \0");
				for(k = 0; k < 4; k++)
				{
					EnvoyerAuMinitel(TamponProposition[k]);
				}
				AfficheTexteMinitel("...\0");
		

				AccederAuxCodes(1, CODE_PROPOSE, TamponProposition);
				Tentatives++;
				AccederATentativesJeuMunstermind(1, Tentatives);
			}
			else
			{
				Resultat = 2;
			}
		}
	}

	return Resultat;
}

void AfficherUnCode(unsigned char Code[])
{
	unsigned char k;

	for(k = 0; k < 4; k++)
	{
		EnvoyerAuMinitel(Code[k]);
	}
}

void AfficherRapportJeuMunstermind(unsigned char Code[], unsigned char Proposition[])
{
	PositionnerCurseurMinitel(22, 2);
	AfficheTexteMinitel("BIEN PLACES : \0");
	EnvoyerAuMinitel(0x30 + IndiquerBienPlaces(Code, Proposition));
	AfficheTexteMinitel(", MAL PLACES : \0");
	EnvoyerAuMinitel(0x30 + IndiquerMalPlaces(Code, Proposition));
}

void CompleterRecapitulatifJeuMunstermind(unsigned char Tour)
{
	unsigned char TamponCode[4];
	unsigned char TamponProposition[4];

	unsigned char Tentatives;

	Tentatives = AccederATentativesJeuMunstermind(0, 0);

	AccederAuxCodes(0, CODE_A_TROUVER, TamponCode);
	AccederAuxCodes(0, CODE_PROPOSE, TamponProposition);
	AfficherRapportJeuMunstermind(TamponCode, TamponProposition);
	Delai(10000);

	/* Ecriture de l'en-tte lors de la premire tentative */
	if(Tentatives == 1)
	{
		PositionnerCurseurMinitel(5, 2);
		AfficheTexteMinitel("N\0");
		
		PositionnerCurseurMinitel(5, 6);
		AfficheTexteMinitel("PROPOSITION\0");

		PositionnerCurseurMinitel(5, 18);
		AfficheTexteMinitel("BIEN PLACES\0");

		PositionnerCurseurMinitel(5, 30);
		AfficheTexteMinitel("MAL PLACES\0");
	}

	PositionnerCurseurMinitel((6 + Tentatives), 2);
	if((Tentatives % 2) == 0)
	{
		ChoisirCouleurCaractere(MINITEL_COULEUR_CARACTERE_BLANC);
	}
	else
	{
		ChoisirCouleurCaractere(MINITEL_COULEUR_CARACTERE_ROUGE);
	}
	if(Tentatives >= 10)
	{

		EnvoyerAuMinitel('1');
	}
	EnvoyerAuMinitel(0x30 + (Tentatives % 10));
	
	PositionnerCurseurMinitel((6 + Tentatives), 6);
	if((Tentatives % 2) == 0)
	{
		ChoisirCouleurCaractere(MINITEL_COULEUR_CARACTERE_BLANC);
	}
	else
	{
		ChoisirCouleurCaractere(MINITEL_COULEUR_CARACTERE_ROUGE);
	}
	AfficherUnCode(TamponProposition);

	PositionnerCurseurMinitel((6 + Tentatives), 18);
	if((Tentatives % 2) == 0)
	{
		ChoisirCouleurCaractere(MINITEL_COULEUR_CARACTERE_BLANC);
	}
	else
	{
		ChoisirCouleurCaractere(MINITEL_COULEUR_CARACTERE_ROUGE);
	}
	EnvoyerAuMinitel(0x30 + IndiquerBienPlaces(TamponCode, TamponProposition));

	PositionnerCurseurMinitel((6 + Tentatives), 30);
	if((Tentatives % 2) == 0)
	{
		ChoisirCouleurCaractere(MINITEL_COULEUR_CARACTERE_BLANC);
	}
	else
	{
		ChoisirCouleurCaractere(MINITEL_COULEUR_CARACTERE_ROUGE);
	}
	EnvoyerAuMinitel(0x30 + IndiquerMalPlaces(TamponCode, TamponProposition));
}

void ReponseJoueurMunstermind(unsigned char Proposition[])
{
	unsigned char Tampon;
	unsigned char Touche;
	unsigned char Reponse;
	unsigned char Compteur = 0;
	unsigned char Etat = 0;

	do
	{
		switch(Etat)
		{
			case 0 :
			{
				do
				{
					Touche = RecevoirDuMinitel();
				}
				while(!((Touche == ' ') || ((Touche >= '0') && (Touche <= '9'))));

				if(Touche == ' ')
				{
					if(Compteur >= 1)
					{
						Compteur--;
						PositionnerCurseurMinitel(23, (3 + Compteur));
						EnvoyerAuMinitel(' ');
						PositionnerCurseurMinitel(23, (3 + Compteur));
					}
				}
				else
				{
					Proposition[Compteur] = Touche;
					EnvoyerAuMinitel(Touche);
					Compteur++;
					if(Compteur >= 4)
					{
						Etat = 1;
					}
				}

				break;
			}
			case 1 :
			{
				Touche = RecevoirDuMinitel();

				if(Touche == ' ')
				{
					PositionnerCurseurMinitel(23, 6);
					EnvoyerAuMinitel(' ');
					PositionnerCurseurMinitel(23, 6);
					Compteur = 3;
					Etat = 0;
				}
				else if(Touche == MINITEL_CARACTERE_RETOUR_LIGNE)
				{
					Etat = 2;
				}

				break;
			}
			case 2 :
			{

				break;
			}
			default :
			{
				Etat = 0;

				break;
			}
		}
	}
	while(Etat != 2);
}
