

#include "h/JeuPendu.h"
#include "h/Affichages.h"
#include "h/FctnADC.h"
#include "h/SemiGraphique.h"
#include "h/Utilitaires.h"

const rom char Mots[256] = "VILLAGE\0\0\0\0\0\0\0\0\0\
DEMANDE\0\0\0\0\0\0\0\0\0\
THERMOPLASTIQUE\0\
VOLUPTUEUSEMENT\0\
PLASTURGIE\0\0\0\0\0\0\
ROBOTIQUE\0\0\0\0\0\0\0\
ZYGOMATIQUE\0\0\0\0\0\
FINALITE\0\0\0\0\0\0\0\0\
KANGOUROU\0\0\0\0\0\0\0\
DEMONSTRATION\0\0\0\
MUSIQUE\0\0\0\0\0\0\0\0\0\
ENCHANTEUR\0\0\0\0\0\0\
AFFABULATION\0\0\0\0\
INVESTISSEMENT\0\0\
ETUDIANT\0\0\0\0\0\0\0\0\
LITTERATURE\0\0\0\0";

unsigned char g_PropositionsJeuPendu = 0;
unsigned char g_ErreursJeuPendu = 0;
unsigned char g_LettresATrouverJeuPendu = 0;

void InitJeuPendu(void)
{
	EnvoyerAuMinitel(0x0C);
	EnvoyerAuMinitel(0x14);
	EnvoyerAuMinitel(0x1E);
	
	PositionnerCurseurMinitel(2, 1);
	ChoisirUnAttribut(MINITEL_LARGEUR_HAUTEUR_DOUBLES);
	AfficheTexteMinitel("3615 PENDU\0");
	ChoisirUnAttribut(MINITEL_LARGEUR_HAUTEUR_NORMALES);

	Delai(9000);

	PositionnerCurseurMinitel(3, 1);
	AfficheTexteMinitel("    ................MMMMMMMMMMMM.......\0");
	PositionnerCurseurMinitel(4, 1);
	AfficheTexteMinitel("    ................M...M....M.........\0");
	PositionnerCurseurMinitel(5, 1);
	AfficheTexteMinitel("    ................M..M.....M.........\0");
	PositionnerCurseurMinitel(6, 1);
	AfficheTexteMinitel("    ................M.M.....M.M........\0");
	PositionnerCurseurMinitel(7, 1);
	AfficheTexteMinitel("    ................MM.......M.........\0");
	PositionnerCurseurMinitel(8, 1);
	AfficheTexteMinitel("    ................M.......MMM........\0");
	PositionnerCurseurMinitel(9, 1);
	AfficheTexteMinitel("    ................M......M.M.M.......\0");
	PositionnerCurseurMinitel(10, 1);
	AfficheTexteMinitel("    ................M........M.........\0");
	PositionnerCurseurMinitel(11, 1);
	AfficheTexteMinitel("    ................M.......M.M........\0");
	PositionnerCurseurMinitel(12, 1);
	AfficheTexteMinitel("    ................M......M...M.......\0");
	PositionnerCurseurMinitel(13, 1);
	AfficheTexteMinitel("    ................M..................\0");

	PositionnerCurseurMinitel(15, 1);
	AfficheTexteMinitel("AFIN DE POUVOIR JOUER DANS DE BONNES\0");
	PositionnerCurseurMinitel(16, 1);
	AfficheTexteMinitel("CONDITIONS, DESACTIVEZ L'ECHO LOCAL\0");
	PositionnerCurseurMinitel(17, 1);
	AfficheTexteMinitel("DU MINITEL.\0");
	PositionnerCurseurMinitel(19, 1);
	AfficheTexteMinitel("POUR CE FAIRE, APPUYEZ SIMULTANEMENT SUR\0");
	PositionnerCurseurMinitel(20, 1);
	AfficheTexteMinitel("LA TOUCHE \"Fcnt\" ET SUR LA TOUCHE \"T\",\0");
	PositionnerCurseurMinitel(21, 1);
	AfficheTexteMinitel("PUIS APPUYEZ SUR LA TOUCHE \"E\".\0");
	PositionnerCurseurMinitel(23, 1);
	AfficheTexteMinitel("APPUYEZ ENSUITE SUR LA TOUCHE \"ENTREE\",\0");
	PositionnerCurseurMinitel(24, 1);
	AfficheTexteMinitel("POUR AINSI COMMENCER LE JEU !\0");

 	while(RecevoirDuMinitel() != MINITEL_CARACTERE_RETOUR_LIGNE);

	EnvoyerAuMinitel(MINITEL_CARACTERE_EFFACEMENT_ECRAN);
	EnvoyerAuMinitel(MINITEL_CURSEUR_DESACTIVE);
	AfficheTexteMinitel("3615 PENDU\0");
	g_PropositionsJeuPendu = 0;
	g_ErreursJeuPendu = 0;

	GenererMot();
}

unsigned char AccederATentativesJeuPendu(unsigned char Modification, unsigned char Valeur)
{


	return 0;
}

unsigned char AccederAuxMots(unsigned char Modification, unsigned char Categorie, unsigned char Valeur[])
{
	unsigned char k;
	unsigned char Taille;
	unsigned char Reponse;

	static unsigned char LettreProposee = 'A';
	static unsigned char MotATrouver[16] = {'A'};
	static unsigned char MotPropose[16] = {'A'};

	if(Modification == 1)
	{
		if(Categorie == MOT_A_TROUVER)
		{
			Taille = Longueur(Valeur);
			if(Taille > 15)
			{
				Taille = 15;
			}
			for(k = 0; k < Taille; k++)
			{
				MotATrouver[k] = Valeur[k];
			}
			MotATrouver[k] = '\0';
		}
		else if(Categorie == MOT_PROPOSE)
		{
			Taille = Longueur(Valeur);
			if(Taille > 15)
			{
				Taille = 15;
			}
			for(k = 0; k < Taille; k++)
			{
				MotPropose[k] = Valeur[k];
			}
			MotPropose[k] = '\0';
		}
		else if(Categorie == LETTRE_PROPOSEE)
		{
			LettreProposee = Valeur[0];
		}
	}

	if(Categorie == MOT_A_TROUVER)
	{
		Taille = Longueur(MotATrouver);
		if(Taille > 15)
		{
			Taille = 15;
		}
		for(k = 0; k < Taille; k++)
		{
			Valeur[k] = MotATrouver[k];
		}
		Valeur[k] = '\0';
	}
	else if(Categorie == MOT_PROPOSE)
	{
		Taille = Longueur(MotPropose);
		if(Taille > 15)
		{
			Taille = 15;
		}
		for(k = 0; k < Taille; k++)
		{
			Valeur[k] = MotPropose[k];
		}
		Valeur[k] = '\0';
	}
	else if(Categorie == LETTRE_PROPOSEE)
	{
		Reponse = LettreProposee;
	}
	
	return Reponse;
}

void GenererMot(void)
{
	unsigned char k;
	unsigned char Indice;

	static unsigned char IndicePrecedent = 0;

	unsigned char Tampon[16];

	Indice = NombrePseudoAleatoire(0, 15);
	if(Indice == IndicePrecedent)
	{
		if(Indice < 15)
		{
			Indice++;
		}
		else
		{
			Indice = 0;
		}
	}
	IndicePrecedent = Indice;
	for(k = 0; k < 16; k++)
	{
		Tampon[k] = Mots[(Indice * 16) + k];
	}

	AccederAuxMots(1, MOT_A_TROUVER, Tampon);

	g_LettresATrouverJeuPendu = Longueur(Tampon);	
}

unsigned char ComparerMots(unsigned char Mot[], unsigned char Proposition[])
{
	unsigned char k;
	unsigned char Taille;
	unsigned char Resultat = 1;

	Taille = Longueur(Proposition);
	if((Taille == 0) || (Taille != Longueur(Mot)))
	{
		Resultat = 0;
	}
	else
	{
		for(k = 0; k < Taille; k++)
		{
			if(Mot[k] != Proposition[k])
			{
				Resultat = 0;
			}
		}
	}

	return Resultat;
}

unsigned char IndiquerLettres(unsigned char Mot[], unsigned char PropositionMot[], unsigned char PropositionLettre)
{
	return TesterDansTableau(Longueur(Mot), PropositionLettre, Mot);
}

void AfficherMot(unsigned char Mot[])
{
	unsigned char k;
	unsigned char Taille;

	Taille = Longueur(Mot);

	for(k = 0; k < Taille; k++)
	{
		EnvoyerAuMinitel(Mot[k]);
	}
}

unsigned char PrendreJeuPendu(unsigned char Tour)
{
	unsigned char k;
	unsigned char Reponse;
	unsigned char Taille;
	unsigned char Resultat = 0;

	unsigned char TamponMot[16];
	unsigned char TamponProposition[16];

	AccederAuxMots(0, MOT_A_TROUVER, TamponMot);
	AccederAuxMots(0, MOT_PROPOSE, TamponProposition);

	if(Tour == 0)	/* Adversaire */
	{
		
	}
	else if(Tour == 1)	/* Joueur */
	{
		if(g_LettresATrouverJeuPendu == 0)
		{
			Resultat = 1;
		}
		else
		{
			if(g_ErreursJeuPendu < 10)
			{
				AfficherDemandeSaisie(2, 22, "LETTRE OU MOT A ESSAYER ?\0");
				Reponse = ReponseJoueurPendu(TamponProposition);
				if(Reponse != 0)	/* Si le joueur a propos une lettre */
				{
					EffacerDemandeSaisie(2, 22, "ESSAI DE LA LETTRE \0");
					EnvoyerAuMinitel(Reponse);
					AfficheTexteMinitel("...\0");
					AccederAuxMots(1, LETTRE_PROPOSEE, TamponProposition);
				}
				else	/* Si le joueur a propos un mot */
				{
					Taille = Longueur(TamponProposition);
					if(Taille > 15)
					{
						Taille = 15;
					}
					EffacerDemandeSaisie(2, 22, "ESSAI DU MOT \0");
					for(k = 0; k < Taille; k++)
					{
						EnvoyerAuMinitel(TamponProposition[k]);
					}
					AfficheTexteMinitel("...\0");
					AccederAuxMots(1, MOT_PROPOSE, TamponProposition);
					TamponProposition[0] = 0;
					AccederAuxMots(1, LETTRE_PROPOSEE, TamponProposition);
				}
			}
			else
			{
				Resultat = 2;
			}
		}
		g_PropositionsJeuPendu++;
	}

	return Resultat;
}

void AfficherRapportJeuPendu(unsigned char Mot[], unsigned char PropositionMot[], unsigned char PropositionLettre)
{
	unsigned char NombreLettresPresentes;

	EffacerDemandeSaisie(2, 22, "\0");
	PositionnerCurseurMinitel(22, 2);
	if(PropositionLettre != 0)
	{
		NombreLettresPresentes = IndiquerLettres(Mot, PropositionMot, PropositionLettre);

		if(NombreLettresPresentes == 0)
		{
			AfficheTexteMinitel("LA LETTRE N'EST PAS PRESENTE \0");
		}
		else
		{
			AfficheTexteMinitel("LA LETTRE EST PRESENTE \0");
			EnvoyerAuMinitel(0x30 + NombreLettresPresentes);
			AfficheTexteMinitel(" FOIS\0");
		}
	}
	else
	{
		if(ComparerMots(Mot, PropositionMot) != 1)
		{
			AfficheTexteMinitel("LE MOT N'EST PAS LE BON\0");
		}	
		else
		{
			AfficheTexteMinitel("LE MOT EST LE BON\0");
		}
	}
}

void CompleterRecapitulatifJeuPendu(unsigned char Tour)
{
	unsigned char k;
	unsigned char PropositionLettre;
	unsigned char NombreLettresMot;
	unsigned char RejetLettre = 0;

	unsigned char TamponMot[16];
	unsigned char TamponProposition[16];

	static unsigned char NombreLettresCorrectesProposees = 0;
	static unsigned char PositionRejets = 0;

	static unsigned char LettresProposees[16] = {'\0'};

	AccederAuxMots(0, MOT_A_TROUVER, TamponMot);
	AccederAuxMots(0, MOT_PROPOSE, TamponProposition);
	PropositionLettre = AccederAuxMots(0, LETTRE_PROPOSEE, 0);

	NombreLettresMot = Longueur(TamponMot);

	if(g_PropositionsJeuPendu == 0)
	{
		PositionnerCurseurMinitel(4, 2);
		for(k = 0; k < NombreLettresMot; k++)
		{
			EnvoyerAuMinitel('_');
			if(k < NombreLettresMot)
			{
				EnvoyerAuMinitel(' ');
			}
		}
		NombreLettresCorrectesProposees = 0;
		PositionRejets = 0;
		RemplirTableau(16, '\0', LettresProposees);
	}
	else
	{
		AfficherRapportJeuPendu(TamponMot, TamponProposition, PropositionLettre);
		Delai(10000);
		if(PropositionLettre != 0)
		{
			RejetLettre = 1;
			PositionnerCurseurMinitel(4, 2);
			for(k = 0; k < NombreLettresMot; k++)
			{
				if(TamponMot[k] == PropositionLettre)
				{
					PositionnerCurseurMinitel(4 , (2 + (2 * k)));
					EnvoyerAuMinitel(PropositionLettre);
					RejetLettre = 0;
					if(TesterDansTableau(16, PropositionLettre, LettresProposees) == 0)
					{
						g_LettresATrouverJeuPendu--;
					}
				}
			}
			if(RejetLettre == 1)
			{
				PositionRejets++;
				PositionnerCurseurMinitel((6 + PositionRejets), 2);
				EnvoyerAuMinitel(PropositionLettre);
				g_ErreursJeuPendu++;
				DessinerElementPendu(g_ErreursJeuPendu);
			}
			else
			{
				if(TesterDansTableau(16, PropositionLettre, LettresProposees) == 0)
				{
					LettresProposees[NombreLettresCorrectesProposees] = PropositionLettre;
					NombreLettresCorrectesProposees++;
				}
			}
		}
		else
		{
			if(ComparerMots(TamponMot, TamponProposition) == 0)
			{
				PositionRejets++;
				PositionnerCurseurMinitel((6 + PositionRejets), 2);
				AfficherMot(TamponProposition);
				g_ErreursJeuPendu++;
				DessinerElementPendu(g_ErreursJeuPendu);
			}
			else
			{
				g_LettresATrouverJeuPendu = 0;
			}
		}
	}
}

unsigned char ReponseJoueurPendu(unsigned char Proposition[])
{
	unsigned char Tampon;
	unsigned char Touche;
	unsigned char Compteur = 0;
	unsigned char Etat = 0;
	unsigned char Reponse = 0;

	do
	{
		switch(Etat)
		{
			case 0 :
			{
				do
				{
					Touche = RecevoirDuMinitel();
				}
				while(!((Touche == MINITEL_CARACTERE_RETOUR_LIGNE) || (Touche == ' ') || ((Touche >= 'A') && (Touche <= 'Z'))));

				if(Touche == ' ')
				{
					if(Compteur >= 1)
					{
						Compteur--;
						PositionnerCurseurMinitel(23, (3 + Compteur));
						EnvoyerAuMinitel(' ');
						PositionnerCurseurMinitel(23, (3 + Compteur));
					}
				}
				else
				{
					if(Touche == MINITEL_CARACTERE_RETOUR_LIGNE)
					{
						if(Compteur >= 1)
						{
							Etat = 2;
						}
					}
					else
					{
						Proposition[Compteur] = Touche;
						EnvoyerAuMinitel(Touche);
						Compteur++;
						if(Compteur >= 15)
						{
							Etat = 1;
						}
						else
						{
							Proposition[Compteur] = '\0';
						}
					}
				}

				break;
			}
			case 1 :
			{
				Touche = RecevoirDuMinitel();

				if(Touche == ' ')
				{
					PositionnerCurseurMinitel(23, 6);
					EnvoyerAuMinitel(' ');
					PositionnerCurseurMinitel(23, 6);
					Compteur--;
					Etat = 0;
				}
				else if(Touche == MINITEL_CARACTERE_RETOUR_LIGNE)
				{
					Etat = 2;
				}

				break;
			}
			case 2 :
			{
				if(Compteur == 1)
				{
					Reponse = Proposition[0];
				}
				Proposition[15] = '\0';
				Etat = 3;

				break;
			}
			case 3 :
			{
				
				break;
			}
			default :
			{
				Etat = 0;

				break;
			}
		}
	}
	while(Etat != 3);

	return Reponse;
}




